
:CONNECT localhost\SQLDEV01

IF EXISTS
  (SELECT * FROM sys.databases WHERE name = 'TestDB')
DROP DATABASE TestDB
GO

CREATE DATABASE TestDB
GO

USE TestDB
GO

--
-- Step 1: create the initiator side
--


IF EXISTS (SELECT * FROM sys.services WHERE name = 'TestInitiator')
    DROP SERVICE TestInitiator;
GO

IF EXISTS 
  (SELECT * FROM sys.service_queues WHERE name = 'TestInitiatorQueue')
    DROP QUEUE TestInitiatorQueue;
GO


-- create queues and services
CREATE QUEUE TestInitiatorQueue
GO

CREATE SERVICE TestInitiator
 ON QUEUE TestInitiatorQueue
 ([DEFAULT])
GO

-- No remote service binding and no user for cert
-- This means:
--   No dialog authentication or encryption
--   All Conversations must be ENCRYPTION OFF 
--   Target must GRANT CONNECT to public


CREATE ROUTE TestRoute1 WITH
	SERVICE_NAME = 'TestTarget',
    ADDRESS = 'TCP://localhost:4567'
GO

CREATE ROUTE TestRoute2 WITH
	SERVICE_NAME = 'TestTarget',
    ADDRESS = 'TCP://localhost:4789'
GO

-- determine the GUID of the TestDB database
SELECT name, service_broker_guid 
FROM sys.databases where name = 'TestDB'
GO

USE MSDB
GO

drop route testroute
go

-- Replace your instance's guid in Broker_Instance
create route [TestRoute]
with
service_name = 'TestInitiator',
-- this is the guid from this side's database
BROKER_INSTANCE = '{6D102140-7910-457F-AAAB-CDEBE9ED4017}',
address = 'LOCAL';
go