

:CONNECT localhost\SQLDEV02

IF EXISTS
  (SELECT * FROM sys.databases WHERE name = 'TestDB')
DROP DATABASE TestDB
GO

CREATE DATABASE TestDB
GO

USE TestDB
GO

--
-- Step 1: create the target side
--


IF EXISTS (SELECT * FROM sys.services WHERE name = 'TestTarget')
    DROP SERVICE [TestTarget];
GO

IF EXISTS 
  (SELECT * FROM sys.service_queues WHERE name = 'TestTargetQueue')
    DROP QUEUE TestTargetQueue;
GO


-- create queues and services
CREATE QUEUE TestTargetQueue
GO

CREATE SERVICE [TestTarget]
 ON QUEUE TestTargetQueue
 ([DEFAULT])
GO

-- This will work with:
-- Dialog encryption turned off or
-- Anonymous remote service binding at initiator or
-- Named remote service binding at initiator
GRANT SEND ON SERVICE::[TestTarget] TO public
GO

-- need a route back to each remote initiator
CREATE ROUTE TestRoute WITH
	SERVICE_NAME = 'TestInitiator',
    ADDRESS = 'TCP://localhost:4321'
GO

-- determine the GUID of the TestDB database
SELECT name, service_broker_guid 
FROM master.sys.databases where name = 'TestDB'
GO

:CONNECT localhost\SQLDEV02

USE MSDB
GO

drop route testroute
go

select * from sys.routes
go

-- Replace your instance's guid in Broker_Instance
create route [TestRoute]
with
service_name = 'TestTarget',
-- this is the guid from this side's database
BROKER_INSTANCE = '{15923DC7-925D-4942-B5B9-558F0DA6035E}',
address = 'LOCAL';
go
  